/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2020, Arnaud Roques
 *
 * Project Info:  http://plantuml.com
 * 
 * If you like this project or if you find it useful, you can support us at:
 * 
 * http://plantuml.com/patreon (only 1$ per month!)
 * http://plantuml.com/paypal
 * 
 * This file is part of PlantUML.
 *
 * THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC
 * LICENSE ("AGREEMENT"). [Eclipse Public License - v 1.0]
 * 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
 * RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.
 * 
 * You may obtain a copy of the License at
 * 
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *
 * Original Author:  Arnaud Roques
 */
package net.sourceforge.plantuml.sequencediagram;

public enum MessageExoType {
	FROM_LEFT, TO_LEFT, FROM_RIGHT, TO_RIGHT;

	public int getDirection() {
		if (this == MessageExoType.FROM_LEFT) {
			return 1;
		}
		if (this == MessageExoType.TO_LEFT) {
			return -1;
		}
		if (this == MessageExoType.TO_RIGHT) {
			return 1;
		}
		if (this == MessageExoType.FROM_RIGHT) {
			return -1;
		}
		throw new IllegalStateException();
	}

	public boolean isLeftBorder() {
		return this == MessageExoType.FROM_LEFT || this == MessageExoType.TO_LEFT;
	}

	public boolean isRightBorder() {
		return this == MessageExoType.FROM_RIGHT || this == MessageExoType.TO_RIGHT;
	}

}
